VERSION 5.00
Begin VB.Form Sample 
   Caption         =   "Sample"
   ClientHeight    =   1005
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2085
   LinkTopic       =   "Form1"
   ScaleHeight     =   1005
   ScaleWidth      =   2085
   StartUpPosition =   3  'Windows ̊l
End
Attribute VB_Name = "Sample"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*****************************************************************************
'* aisa15s.bas                                                               *
'*                                                                           *
'* aISA-A15                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'* Date 1998/04/21                                                           *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************
Option Explicit

Private Const szA15 = "aISA-A15"

Private Sub Form_Load()
    
    Dim strbuf As String
    Dim dwDllVer As Long, dwDrvVer As Long
    Dim bResult As Boolean              ' 
    Dim wLogSlot As Integer             ' foCXi[
    Dim ri As AISA15RESOURCE_NT         ' \[X
    Dim md As AISA15MODE                ' TvO[h
    Dim dwNumData As Long
    Dim dwStatus As Long
    Dim wData() As Integer
    Dim i As Long
    Dim dwExIn0 As Long, dwExIn1 As Long, dwExTrg As Long

'---------------------------------------------------------------------------
    ' aisa15.dll ̎gp錾
    If Aisa15wDllOpen() = False Then
        ErrorMessage (AISA15_SLOT_AUTO)
        Exit Sub                ' aisa15.dll ̃[hɎs܂
    End If

'---------------------------------------------------------------------------
    ' o[Wԍ\
    If Aisa15wGetVersion(dwDllVer, dwDrvVer) = False Then ' aISA-A15DLL,Driver̃o[Wԍ擾
        ErrorMessage (AISA15_SLOT_AUTO)
        Exit Sub
    End If

    strbuf = "GetVersion" + Chr(10) + _
             "DLL Version: &H" + Hex(dwDllVer) + Chr(10) + _
             "Drv Version: &H" + Hex(dwDrvVer)
    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-A15̎gp錾
    wLogSlot = AISA15_SLOT_AUTO     ' gp̃foCXT܂B
    
    ' ꍇA̎̃foCXi[܂B
    ' EBhEnhȂ̂ 0 Zbg܂B
    ' EBhEnhZbg΁Ae탁bZ[W܂B
    ' 3ԖڂɃZbgẮAbZ[WID̊ƂȂlłB
    ' ۂ̃bZ[WID͂̊lɃItZbg(WM_EOCȂ)̂ƂȂ܂B
    bResult = Aisa15wCreate(wLogSlot, 0, &H6401, 0)
                                             
    If bResult = False Then         ' foCX܂B
        ErrorMessage (wLogSlot)
        Exit Sub
    End If
    
    strbuf = "aISA-A15 Created" + Chr(10) + Chr(10) + _
          "LogSlot: " + Str(wLogSlot)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' \[X擾
    If Aisa15wGetResource(wLogSlot, ri) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "Board Name: " + szA15 + Chr(10) + _
             "IO Base Address: &H" + Hex(ri.dwIOPortBase) + Chr(10) + _
             "IRQ: " + Str(ri.dwIRQRegisters) + Chr(10) + _
             "DMA: " + Str(ri.dwNumDMAs)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvO[h̐ݒ
    md.iChFirst = 0         ' TvOJn`l(0 ` 15)
    md.iChLast = 15         ' TvOI`l(0 ` 15)
    md.cwBuffer = 256       ' obt@TCYi[hPʁj
    md.dwTimer = 500        ' ^C}l(1`50000000)
    md.dwMode = MODE_03     ' 샂[h(1`10)

    If Aisa15wSetMode(wLogSlot, md) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "aISA-A15 Sampling Mode" + Chr(10) + _
             "TvOJn`l=" + Str(md.iChFirst) + Chr(10) + _
             "TvOI`l=" + Str(md.iChLast) + Chr(10) + _
             "obt@TCY=" + Str(md.cwBuffer) + Chr(10) + _
             "^C}l=" + Str(md.dwTimer) + Chr(10) + _
             "샂[h=" + Str(md.dwMode)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvOJn
    If Aisa15wStartSampling(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-A15 Sampling Started")

'---------------------------------------------------------------------------
    ' TvOEXe[^X̎擾
    If Aisa15wGetSamplingStatus(wLogSlot, dwNumData, dwStatus) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "TvOEXe[^X擾" + Chr(10) + _
             "f[^=" + Str(dwNumData) + Chr(10) + _
             "Xe[^X=" + Str(dwStatus)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' TvOς݃f[^̎擾
    If dwNumData > 0 Then
        ReDim wData(1 To dwNumData)
    
        If Aisa15wGetData(wLogSlot, dwNumData, wData) = False Then
            ErrorMessage (wLogSlot)
            Exit Sub
        End If
    
        strbuf = "TvOς݃f[^擾" + Chr(10)
        For i = 1 To dwNumData
            strbuf = strbuf + Str(i) + ":&H" + Hex(wData(i)) + "  "
    
            If (i + 1) Mod 4 = 0 Then   ' 4 Ŋ؂
                strbuf = strbuf + Chr(10)
            End If
        Next i
    
        ResultMessage (strbuf)
    End If

'---------------------------------------------------------------------------
    ' TvO~
    If Aisa15wStopSampling(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-A15 Sampling Stopped")

'---------------------------------------------------------------------------
    ' O͏Ԃ̎擾
    If Aisa15wGetExIn(wLogSlot, dwExIn0, dwExIn1, dwExTrg) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    strbuf = "O͏Ԃ̎擾" + Chr(10) + _
             "EXIN0̏=&H" + Hex(dwExIn0) + Chr(10) + _
             "EXIN1̏=&H" + Hex(dwExIn1) + Chr(10) + _
             "EXTRG̏=&H" + Hex(dwExTrg)

    ResultMessage (strbuf)

'---------------------------------------------------------------------------
    ' aISA-A15̎gpJ
    If Aisa15wClose(wLogSlot) = False Then
        ErrorMessage (wLogSlot)
        Exit Sub
    End If

    ResultMessage ("aISA-A15 Closed")

'---------------------------------------------------------------------------
    ' aisa15.dll ̎gpJ
    If Aisa15wDllClose() = False Then
        MsgBox "DLL Unload error", vbOKOnly + vbCritical
        Exit Sub        ' aisa15.dll ̃A[hɎs܂B
    End If

End Sub

' ʂ\
Private Sub ResultMessage(lpszbuf As String)
    
    MsgBox lpszbuf, vbOKOnly + vbInformation

End Sub


' G[bZ[W\
Private Sub ErrorMessage(wLogSlot As Integer)
    
    Dim dwRes As Long
    Dim szbuf As String
    
    dwRes = Aisa15wGetLastError(wLogSlot)

    Select Case dwRes
    Case AISA15_ERR_WRAPDLL
        szbuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szbuf = "aISA-A15 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szbuf, vbOKOnly + vbCritical

End Sub
